#!/usr/bin/env bash

set -eu

IFS= read -d '' HELP_TEXT <<-EOF || true
BridgeDB frontend build script

Usage: ./build.sh <LEKTOR_ENV>

LEKTOR_ENV:	"dev" or "prod" - sets the build environment for templates. "prod" inserts mako templates for the BridgeDB backend to fill in, while "dev" inserts fake example data for testing.
EOF

if [[ $# -ne 1 || ( $1 != "dev" && $1 != "prod" ) ]]; then
    printf "%s" "$HELP_TEXT"
    exit 1
fi

set -x

# "dev" for test data or "prod" to generate mako templates
export LEKTOR_ENV="$1"

langs=(be ca cs da de es es_AR fr ga he hr hu is it ja ka lt mk ml nb nl pl pt_BR pt_PT ro ru sk sq sv tr zh_CN)

# lektor generates pages as <locale>/<page url>, but bridgedb expects /<page url>?lang=<locale>
# we can't just copy the pages as-is, so we need to copy the translated pages into a different
# directory structure for bridgedb


# bridgedb uses a different directory structure for pages than the structure generated by lektor.
# we need to copy each language one-by-one into the bridgedb directories
copy_lang() {
    set +u

    # realpath is used to normalize path names.
    # mostly used for the default locale '' (empty string)
    lang="$1"
    mkdir -p $(realpath public/"$lang")
    cp $(realpath public_tmp/"$lang"/index.html) $(realpath public/"$lang")
    cp $(realpath public_tmp/"$lang"/captcha/index.html) $(realpath public/"$lang"/captcha.html)
    cp $(realpath public_tmp/"$lang"/bridges/index.html) $(realpath public/"$lang"/bridges.html)
    cp $(realpath public_tmp/"$lang"/options/index.html) $(realpath public/"$lang"/options.html)

    set -u
}

# make sure we're in the frontend directory
cd "$(dirname "$0")"

# make sure lego is cloned
git submodule update --init

if [ ! -d i18n ]
then
    git clone https://gitlab.torproject.org/tpo/translation/ --single-branch --branch=bridgedb i18n
fi

pip install -r lego/lektor-requirements.txt
pip install -r requirements.txt

# TODO: maybe use a mktemp instead of public_tmp?
lektor build -O public_tmp -f scss
rm -rf public
mkdir public

# lektor generates the default locale as /<page url>, with no locale in the path
copy_lang ''

for lang in $langs
do
    copy_lang "$lang"
done

cp -r public_tmp/static public/assets

rm -rf public_tmp
